## sparse 0.4.1+git20081218

=== Makefile ===
--- 
+++ 
@@ -1,19 +1,23 @@
 VERSION=0.4.1
 
-OS ?= linux
-
-CC ?= gcc
-CFLAGS ?= -O2 -finline-functions -fno-strict-aliasing -g
+OS = linux
+
+
+CC = gcc
+CFLAGS = -O2 -finline-functions -fno-strict-aliasing -g
 CFLAGS += -Wall -Wwrite-strings
-LDFLAGS ?= -g
-AR ?= ar
+LDFLAGS += -g
+AR = ar
+
+#
+# For debugging, uncomment the next one
+#
+#CFLAGS += -O0 -DDEBUG -g3 -gdwarf-2
 
 HAVE_LIBXML=$(shell pkg-config --exists libxml-2.0 && echo 'yes')
 
-#
-# For debugging, uncomment the next one
-#
-CFLAGS += -DDEBUG
+
+CFLAGS += -DGCC_BASE=\"$(shell $(CC) --print-file-name=)\"
 
 DESTDIR=
 PREFIX=$(HOME)
@@ -145,7 +149,7 @@
 allocate.o: $(LIB_H)
 ptrlist.o: $(LIB_H)
 parse.o: $(LIB_H)
-pre-process.o: $(LIB_H) pre-process.h
+pre-process.o: $(LIB_H)
 scope.o: $(LIB_H)
 show-parse.o: $(LIB_H)
 symbol.o: $(LIB_H)
@@ -184,14 +188,11 @@
 compat-mingw.o: $(LIB_H)
 compat-cygwin.o: $(LIB_H)
 
-pre-process.h:
-	$(QUIET_GEN)echo "#define GCC_INTERNAL_INCLUDE \"`$(CC) -print-file-name=include`\"" > pre-process.h
-
 .c.o:
 	$(QUIET_CC)$(CC) -o $@ -c $(CFLAGS) $<
 
 clean: clean-check
-	rm -f *.[oa] $(PROGRAMS) $(SLIB_FILE) pre-process.h sparse.pc
+	rm -f *.[oa] *.so $(PROGRAMS) $(SLIB_FILE) pre-process.h sparse.pc
 
 dist:
 	@if test "`git describe`" != "$(VERSION)" ; then \
