=== debian/control ===
Source: sparse
Maintainer: Pierre Habouzit <madcoder@debian.org>
Uploaders: Loic Minier <lool@dooz.org>
Section: non-free/devel
Priority: optional
Build-Depends: debhelper (>= 8), libxml2-dev, libgtk2.0-dev
Standards-Version: 3.9.1
Vcs-Git: git://git.debian.org/git/collab-maint/sparse.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/sparse.git
XS-autobuild: yes

Package: sparse
Architecture: any
Section: non-free/devel
Priority: optional
Depends: ${misc:Depends}, ${shlibs:Depends}
Homepage: http://sparse.wiki.kernel.org/index.php/Main_Page
Description: semantic parser of source files
 Sparse, the semantic parser, provides a compiler frontend capable of
 parsing most of ANSI C as well as many GCC extensions, and a collection
 of sample compiler backends, including a static analyzer also called
 "sparse". Sparse provides a set of annotations designed to convey
 semantic information about types, such as what address space pointers
 point to, or what locks a function acquires or releases.
 .
 Sparse can be invoked directly as "sparse" or via the "cgcc" wrapper
 around the C compiler.
