=== debian/changelog ===
sparse (0.4.5~rc1-1) unstable; urgency=low

  [ Uwe Kleine-König ]
  * new upstream release candidate
  * switch to debhelper 9 to get hardend binaries
  * Standards-Version: 3.9.4 (no changes needed)
  * Add patch to add --as-needed to LDFLAGS (except for LLVM).
  * Add missing ${perl:Depends}.

  [ Loïc Minier ]
  * Use my Debian address in control.
  * Update Vcs fields to use anonscm URLs.
  * Don't repeat Section and Priority in binary package stanza.
  * Fix typo in copyright file.
  * Add watch file.
  * Build sparse-llvm by adding llvm-dev (>= 3.0~) build-dep.
  * Add patch to pass CFLAGS and CPPFLAGS from rules to Makefile, notably
    hardening flags.

 -- Loïc Minier <lool@debian.org>  Sat, 15 Jun 2013 01:06:33 +0200
