=== debian/control ===
--- 
+++ 
@@ -1,19 +1,20 @@
 Source: sparse
 Maintainer: Pierre Habouzit <madcoder@debian.org>
-Uploaders: Loic Minier <lool@dooz.org>
+Uploaders: Loïc Minier <lool@debian.org>
 Section: non-free/devel
 Priority: optional
-Build-Depends: debhelper (>= 8), libxml2-dev, libgtk2.0-dev
-Standards-Version: 3.9.1
-Vcs-Git: git://git.debian.org/git/collab-maint/sparse.git
-Vcs-Browser: http://git.debian.org/?p=collab-maint/sparse.git
+Build-Depends: debhelper (>= 9),
+               libxml2-dev,
+               libgtk2.0-dev,
+               llvm-dev (>= 1:3.0~)
+Standards-Version: 3.9.4
+Vcs-Git: git://anonscm.debian.org/collab-maint/sparse.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/sparse.git
 XS-autobuild: yes
 
 Package: sparse
 Architecture: any
-Section: non-free/devel
-Priority: optional
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}, ${perl:Depends}
 Homepage: http://sparse.wiki.kernel.org/index.php/Main_Page
 Description: semantic parser of source files
  Sparse, the semantic parser, provides a compiler frontend capable of
