=== debian/watch ===
version=3
https://www.kernel.org/pub/software/devel/sparse/dist/ \
  sparse-([\d\.]+)\.tar\.bz2 \
  debian uupdate
