=== debian/changelog ===
sparse (0.5.0-4) unstable; urgency=medium

  * Upload to unstable

 -- Uwe Kleine-König <ukleinek@debian.org>  Sat, 12 Aug 2017 22:45:58 +0200

sparse (0.5.0-3) experimental; urgency=medium

  * Add Breaks: and Replaces: to sparse-test-inspect as required by package
    split in 0.5.0-2. (Closes: #863966)

 -- Uwe Kleine-König <ukleinek@debian.org>  Fri, 02 Jun 2017 14:42:55 +0200

sparse (0.5.0-2) experimental; urgency=medium

  * Split package to have test-inspect in a separate package. This allows to
    install sparse without having to install tons of GTK+ and Gnome libs.
    Patch by W. Martin Borgert (Closes: #845626)
  * Cherry-pick two commits from upstream fixing false warnings about IS_ERR
    when checking the kernel sources. (Closes: #862319)

 -- Uwe Kleine-König <ukleinek@debian.org>  Thu, 11 May 2017 10:56:10 +0200

sparse (0.5.0-1) unstable; urgency=medium

  * new upstream release (Closes: #743923)
    - upstream relicensed under MIT (Closes: #524319)
  * provide PREFIX already at build time (Closes: #660274)
  * Standards-Version: 3.9.6 (no changes needed) 
  * Merge 0.4.5~rc1-2, thanks to Andreas Beckmann 
  * Take over maintenance, drop Loïc from Uploaders (Closes: #794643)
  * cherry-pick patches from upstream to make sparse multi-arch aware
    (Closes: #755979)

 -- Uwe Kleine-König <ukleinek@debian.org>  Tue, 03 Nov 2015 00:43:13 +0100

sparse (0.4.5~rc1-2~deb8u1) jessie; urgency=medium

  * QA upload.
  * Rebuild for jessie.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 09 Sep 2015 22:28:16 +0200

sparse (0.4.5~rc1-2) unstable; urgency=medium

  [ Andreas Beckmann ]
  * QA upload.
  * Set maintainer to Debian QA Group.  (See #794643)
  * Fix Homepage and Vcs-Browser URLs.
  * Refresh patch to apply without fuzz.

  [ Uwe Kleine-König ]
  * Cherry-pick commit from upstream to fix build failure with llvm-3.5.
  * Temporarily build-depend on libedit-dev because llvm-config claims to need
    that.  (Closes: #793197)

 -- Andreas Beckmann <anbe@debian.org>  Sat, 08 Aug 2015 13:17:27 +0200
