=== debian/rules ===
#!/usr/bin/make -f

export PREFIX=/usr

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- V=1

override_dh_auto_test:
	dh_auto_test -- V=1

override_dh_auto_install:
	dh_auto_install -- V=1
