## sparse 0.5.1

=== debian/changelog ===
sparse (0.5.1-2) unstable; urgency=medium

  * Note Debian package version in sparse's version string
  * Fix Vcs URL to not use an insecure URI
  * Switch to debhelper 10
  * Provide a patch description for the last patch lacking one
  * new patch to fix FTBFS on armhf

 -- Uwe Kleine-König <ukleinek@debian.org>  Tue, 26 Sep 2017 09:42:03 +0200

sparse (0.5.1-1) unstable; urgency=medium

  * New upstream release
  * Additional patch from upstream:
    - 23a393b1cd48 ("Sparse preprocessing bug with zero-arg variadic macros")
    - 2093505d7b70 ("compile-i386.c: fix a memory leak in sort_array()")
    - f1e4ba13d149 ("build: disable sparse-llvm on non-x86")
  * Disable llvm on !x86
  * Update debian/watch to look at git.kernel.org instead of the download
    directory (which wasn't used for the last release).
  * Standards-Version: 4.1.0 (no changes needed)
  * new patch to improve handling of autogenerated version.h
  * Drop Build-Depends: libedit-dev which was ony added as a work around
    as llvm-config --libs issued -ledit.

 -- Uwe Kleine-König <ukleinek@debian.org>  Fri, 22 Sep 2017 09:04:19 +0200
