=== debian/control ===
--- 
+++ 
@@ -2,14 +2,13 @@
 Maintainer: Uwe Kleine-König <ukleinek@debian.org>
 Section: devel
 Priority: optional
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper (>= 10),
                libxml2-dev,
                libgtk2.0-dev,
-               llvm-dev (>= 1:3.0~),
-               libedit-dev
-Standards-Version: 3.9.6
-Vcs-Git: git://anonscm.debian.org/collab-maint/sparse.git
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/sparse.git
+               llvm-dev (>= 1:3.0~) [amd64 i386],
+Standards-Version: 4.1.0
+Vcs-Git: https://anonscm.debian.org/git/collab-maint/sparse.git
+Vcs-Browser: https://anonscm.debian.org/git/collab-maint/sparse.git
 Homepage: https://sparse.wiki.kernel.org/
 
 Package: sparse
