## sparse 0.5.2

=== debian/changelog ===
sparse (0.5.2-1) unstable; urgency=medium

  * New upstream release (Closes: #895598)
    - cc58fdcfb856 ("fix cgcc ELF version for ppc64/pcc64le") fixed the build
      on ppc64
    - Since 9d58bbdf7865 ("Makefile: provide CFLAGS for command line
      override.") patch pass-down-cflags isn't needed any more and so was
      dropped. Added a simpler patch to honor CPPFLAGS.
    - several patches are included and were dropped accordingly:
      - 23a393b1cd48 ("Sparse preprocessing bug with zero-arg variadic macros")
      - f1e4ba13d149 ("build: disable sparse-llvm on non-x86")
      - 4b7b6b63f606 ("cgcc: provide __ARM_PCS_VFP for armhf")
      - 57efc7462a88 ("cgcc: teach cgcc about GNU/kFreeBSD")
      - 2093505d7b70 ("compile-i386.c: fix a memory leak in sort_array()")
  * move sparse.pc to /usr/lib/${DEB_HOST_MULTIARCH}/pkgconfig/
  * Bump standards versions to 4.1.4 (no changes necessary)

 -- Uwe Kleine-König <ukleinek@debian.org>  Thu, 19 Apr 2018 17:50:13 +0000
