=== debian/control ===
--- 
+++ 
@@ -6,9 +6,9 @@
                libxml2-dev,
                libgtk2.0-dev,
                llvm-dev (>= 1:3.0~) [amd64 i386],
-Standards-Version: 4.1.0
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/sparse.git
-Vcs-Browser: https://anonscm.debian.org/git/collab-maint/sparse.git
+Standards-Version: 4.1.4
+Vcs-Git: https://salsa.debian.org/ukleinek/sparse.git
+Vcs-Browser: https://salsa.debian.org/ukleinek/sparse
 Homepage: https://sparse.wiki.kernel.org/
 
 Package: sparse
