=== debian/changelog ===
sparse (0.6.0-3) unstable; urgency=medium

  * Refresh patches from upstream
  * Fix possible build failure that happend on sparc64 for 0.6.0-2. Patch from
    upstream.
  * New patch to honor CFLAGS from debhelper and so make the build
    reproducible.

 -- Uwe Kleine-König <ukleinek@debian.org>  Tue, 12 Feb 2019 21:42:40 +0100

sparse (0.6.0-2) unstable; urgency=medium

  * New patch to fix FTBFS on m68k
  * New patch to improve grepability for failed tests
  * New patches from upstream to address build failures in 0.6.0-1. Thanks to
    Luc Van Oostenryck. (Closes: #921554)
  * New patch to fix cgcc on mips.

 -- Uwe Kleine-König <ukleinek@debian.org>  Thu, 07 Feb 2019 21:20:33 +0100

sparse (0.6.0-1) unstable; urgency=medium

  * New upstream version (Closes: #920776)
    - Several patches are included and were dropped accordingly
      - 3ff507b6e9e6 ("build: pass CPPFLAGS to compiler")
      - 081679882c3f ("build: add *.o to clean-check pattern")
      - 5844e1713cf6 ("build: only generate version.h when needed")
    - Refresh remaining patches
    - Drop include and pkg-config files as upstream stopped installing them
      (c3490e701eaa ("build: remove unused support for pkgconfig"))
  * Bump standards versions to 4.3.0 (no changes necessary)
  * Switch to debhelper 12

 -- Uwe Kleine-König <ukleinek@debian.org>  Wed, 30 Jan 2019 15:35:42 +0100

sparse (0.5.2-2) unstable; urgency=medium

  * Depend on gcc-8, let cgcc use the versioned compiler command and let
    sparse use gcc-8's include files (Closes: #906472)
  * Support "terse" in DEB_BUILD_OPTIONS
  * Don't require root for building (Rules-Requires-Root: no)
  * Standards-Version: 4.2.1 (no changes needed)

 -- Uwe Kleine-König <ukleinek@debian.org>  Mon, 08 Oct 2018 14:25:04 +0200
