=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,11 @@
 include /usr/share/dpkg/pkg-info.mk
 include /usr/share/dpkg/vendor.mk
 
-DH_MAKE_ARGS = V=1 SPARSE_VERSION="\$$(VERSION) ($(DEB_VENDOR): $(DEB_VERSION))" PREFIX=/usr PKGCONFIGDIR=/usr/lib/${DEB_HOST_MULTIARCH}/pkgconfig
+DH_MAKE_ARGS = SPARSE_VERSION="\$$(VERSION) ($(DEB_VENDOR): $(DEB_VERSION))" PREFIX=/usr
+
+ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
+DH_MAKE_ARGS += V=1
+endif
 
 %:
 	dh $@
